Modify

Opened 10 years ago

Closed 3 years ago

#3123 closed defect (fixed)

AR7 serial is broken

Reported by: matteo Owned by: florian
Priority: high Milestone:
Component: kernel Version:
Keywords: Cc:

Description

this is the log:

Linux version 2.6.24 (matteo@raver) (gcc version 4.2.3) #1 Fri Feb 8 01:44:28 CET 2008
console [early0] enabled
CPU revision is: 00018448 (MIPS 4KEc)
Clocks: Async mode
Clocks: Setting DSP clock
Clocks: prediv: 1, postdiv: 1, mul: 5
Clocks: base = 25000000, frequency = 125000000, prediv = 1, postdiv = 2, postdiv2 = 1, mul = 10
Clocks: Setting CPU clock
Adjusted requested frequency 211000000 to 211968000
Clocks: prediv: 1, postdiv: 1, mul: 6
Clocks: base = 35328000, frequency = 211968000, prediv = 1, postdiv = 1, postdiv2 = -1, mul = 6
Clocks: Setting USB clock
Adjusted requested frequency 48000000 to 48076920
Clocks: prediv: 13, postdiv: 1, mul: 5
Clocks: base = 125000000, frequency = 48000000, prediv = 13, postdiv = 1, postdiv2 = -1, mul = 5
TI AR7 (TNETD7200), ID: 0x002b, Revision: 0x10
Determined physical RAM map:
 memory: 01000000 @ 14000000 (usable)
Entering add_active_range(0, 81920, 86016) 0 entries of 256 used
Initrd not found or empty - disabling initrd
Zone PFN ranges:
  Normal      81920 ->    86016
Movable zone start PFN for each node
early_node_map[1] active PFN ranges
    0:    81920 ->    86016
On node 0 totalpages: 4096
  Normal zone: 32 pages used for memmap
  Normal zone: 0 pages reserved
  Normal zone: 4064 pages, LIFO batch:0
  Movable zone: 0 pages used for memmap
Built 1 zonelists in Zone order, mobility grouping off.  Total pages: 4064
Kernel command line: init=/etc/preinit rootfstype=squashfs,jffs2, console=ttyS0,38400n8
Primary instruction cache 16kB, VIPT, 4-way, linesize 16 bytes.
Primary data cache 8kB, 4-way, VIPT, no aliases, linesize 16 bytes
Synthesized clear page handler (26 instructions).
Synthesized copy page handler (46 instructions).
Synthesized TLB refill handler (20 instructions).
Synthesized TLB load handler fastpath (32 instructions).
Synthesized TLB store handler fastpath (32 instructions).
Synthesized TLB modify handler fastpath (31 instructions).
PID hash table entries: 64 (order: 6, 256 bytes)
Dentry cache hash table entries: 2048 (order: 1, 8192 bytes)
Inode-cache hash table entries: 1024 (order: 0, 4096 bytes)
Memory: 12528k/16384k available (2019k kernel code, 3856k reserved, 428k data, 124k init, 0k highmem)
Calibrating delay loop... 211.35 BogoMIPS (lpj=1056768)
Mount-cache hash table entries: 512
net_namespace: 64 bytes
NET: Registered protocol family 16
Time: MIPS clocksource has been installed.
Switched to high resolution mode on CPU 0
NET: Registered protocol family 2
IP route cache hash table entries: 1024 (order: 0, 4096 bytes)
TCP established hash table entries: 512 (order: 0, 4096 bytes)
TCP bind hash table entries: 512 (order: -1, 2048 bytes)
TCP: Hash tables configured (established 512 bind 512)
TCP reno registered
squashfs: version 3.0 (2006/03/15) Phillip Lougher
Registering mini_fo version $Id$
JFFS2 version 2.2. (NAND) (SUMMARY)  © 2001-2006 Red Hat, Inc.
io scheduler noop registered
io scheduler deadline registered (default)
Serial: 8250/16550 driver $Revision: 1.90 $ 2 ports, IRQ sharing disabled
serial8250: ttyS0 at MMIO 0x8610e00 (irq = 15) is a TI-AR7
-------[ here console disappears ]----------
console handover: boot [early0] -> real [ttyS0]
Fixed MDIO Bus: probed
physmap platform flash device: 00800000 at 10000000
physmap-flash.0: Found 1 x16 devices at 0x0 in 16-bit bank
physmap-flash.0: Found an alias at 0x400000 for the chip at 0x0
 Amd/Fujitsu Extended Query Table at 0x0040
physmap-flash.0: Swapping erase regions for broken CFI table.
number of CFI chips: 1
cfi_cmdset_0002: Disabling erase-suspend-program due to code brokenness.
cmdlinepart partition parsing not available
RedBoot partition parsing not available
4 ar7part partitions found on MTD device physmap-flash.0
Creating 4 MTD partitions on "physmap-flash.0":
0x00000000-0x00010000 : "loader"
0x00010000-0x00020000 : "config"
0x00020000-0x00400000 : "linux"
0x000e4eff-0x00400000 : "rootfs"
mtd: partition "rootfs" doesn't start on an erase block boundary -- force read-only
mtd: partition "rootfs" set to be root filesystem
mtd: partition "rootfs_data" created automatically, ofs=280000, len=180000 
0x00280000-0x00400000 : "rootfs_data"
ar7_wdt: disabling watchdog timer
ar7_wdt: timer margin 59 seconds (prescale 65535, change 57180, freq 62500000)
Registered led device: status
vlynq0: regs 0x08611800, irq 29, mem 0x04000000
nf_conntrack version 0.5.0 (1024 buckets, 4096 max)
ip_tables: (C) 2000-2006 Netfilter Core Team
TCP vegas registered
----[ now appears again after `mknod /dev/console c 5 1` ]-------
NET: Registered protocol family 1
NET: Registered protocol family 17
802.1Q VLAN Support v1.8 Ben Greear <greearb@candelatech.com>
All bugs added by David S. Miller <davem@redhat.com>
VFS: Mounted root (squashfs filesystem) readonly.
Freeing unused kernel memory: 124k freed
Please be patient, while OpenWrt loads ...
Algorithmics/MIPS FPU Emulator v1.5
mini_fo: using base directory: /
mini_fo: using storage directory: /tmp/root
NET: Registered protocol family 10
NET: Registered protocol family 8
NET: Registered protocol family 20
PPP generic driver version 2.4.2
IPv6 over IPv4 tunneling driver

Attachments (3)

ar7-serial-fix.diff (2.3 KB) - added by anonymous 9 years ago.
ar7-serial-fix.2.diff (2.3 KB) - added by anonymous 9 years ago.
ar7-serial-fix.3.diff (2.3 KB) - added by anonymous 9 years ago.

Download all attachments as: .zip

Change History (33)

comment:1 Changed 10 years ago by nabcore

Not seeing this on r10588 , could it be related to you using gcc 4.2.3?

comment:2 Changed 10 years ago by loswillios

no, I'm suffering from the same error with a standard build (gcc-4.1.2)

comment:3 Changed 10 years ago by anonymous

I see the exact same problem, but from a build with the recent '500-serial-kludge' patch. The output returns at:

- preinit -                                                                     
switching to jffs2                                                              
mini_fo: using base directory: /                                                
mini_fo: using storage directory: /jffs                                         
- init -                                                                        
                                                                                
Please press Enter to activate this console.                                    

<OpenWRT banner snipped>

root@(none):/# NET: Registered protocol family 8                                
NET: Registered protocol family 20                                              
PPP generic driver version 2.4.2                                                
registered device TI Avalanche SAR                                              
Ohio250(7200/7100A2) detected                                                   
requesting firmware image "ar0700xx.bin"                                        
tn7dsl_set_modulation : Setting mode to 0x1                                     
Creating new root folder avalanche in the proc for the driver stats             
Texas Instruments ATM driver: version:[7.03.01.00]                              
                                                                                
root@(none):/#      

The weird thing is i get what seem to be bootup messages output to the terminal well after getting the prompt.

comment:4 Changed 10 years ago by anonymous

Oh, I see the same thing with an AVM 7140. Problem is, with the AVM, I'm trying to find out why it resets before it finishes booting - so those missing boot messages would be nice to see.

comment:5 Changed 10 years ago by loswillios

This is the log from my Speedport W701V before it resets itself and reboots:

<Error: environment variable "reserved" not set.>
Setting default address : 00:04:0E:FF:FF:00
<Error: environment variable "bluetooth" not set.>
Setting default address : 00:04:0E:FF:FF:07

(AVM) EVA Revision: 1.153 Version: 1153
(C) Copyright 2005 AVM Date: Jun 21 2006 Time: 12:56:20 (0) 2 0-11111

[FLASH:] MACRONIX Top-MirrorBit-Flash 8MB 32 Bytes WriteBuffer
[FLASH:](Eraseregion [0] 127 sectors a 64kB) 
[FLASH:](Eraseregion [1] 8 sectors a 8kB) 
[SYSTEM:] OHIO on 211MHz/125MHz 

Eva_AVM >AVM decompress Kernel:
....................done
start kernel
Linux version 2.6.24.2 (jan@server) (gcc version 4.1.2) #1 Wed Feb 27 12:44:10 CET 2008
console [early0] enabled
CPU revision is: 00018448 (MIPS 4KEc)
Clocks: Async mode
Clocks: Setting DSP clock
Clocks: base = 25000000, frequency = 125000000, prediv = 1, postdiv = 2, postdiv2 = 1, mul = 10
Clocks: Setting CPU clock
Adjusted requested frequency 211000000 to 211968000
Clocks: base = 35328000, frequency = 211968000, prediv = 1, postdiv = 1, postdiv2 = -1, mul = 6
Clocks: Setting USB clock
Adjusted requested frequency 48000000 to 48076920
Clocks: base = 125000000, frequency = 48000000, prediv = 13, postdiv = 1, postdiv2 = -1, mul = 5
TI AR7 (TNETD7200), ID: 0x002b, Revision: 0x11
Determined physical RAM map:
 memory: 02000000 @ 14000000 (usable)
Initrd not found or empty - disabling initrd
Zone PFN ranges:
  Normal      81920 ->    90112
Movable zone start PFN for each node
early_node_map[1] active PFN ranges
    0:    81920 ->    90112
Built 1 zonelists in Zone order, mobility grouping on.  Total pages: 8128
Kernel command line: init=/etc/preinit rootfstype=squashfs,jffs2, console=ttyS0,38400n8
Primary instruction cache 16kB, VIPT, 4-way, linesize 16 bytes.
Primary data cache 8kB, 4-way, VIPT, no aliases, linesize 16 bytes
Synthesized clear page handler (26 instructions).
Synthesized copy page handler (46 instructions).
Synthesized TLB refill handler (20 instructions).
Synthesized TLB load handler fastpath (32 instructions).
Synthesized TLB store handler fastpath (32 instructions).
Synthesized TLB modify handler fastpath (31 instructions).
PID hash table entries: 128 (order: 7, 512 bytes)
Dentry cache hash table entries: 4096 (order: 2, 16384 bytes)
Inode-cache hash table entries: 2048 (order: 1, 8192 bytes)
Memory: 28768k/32768k available (2023k kernel code, 4000k reserved, 424k data, 128k init, 0k highmem)
Mount-cache hash table entries: 512
net_namespace: 64 bytes
NET: Registered protocol family 16
Time: MIPS clocksource has been installed.
NET: Registered protocol family 2
IP route cache hash table entries: 1024 (order: 0, 4096 bytes)
TCP established hash table entries: 1024 (order: 1, 8192 bytes)
TCP bind hash table entries: 1024 (order: 0, 4096 bytes)
TCP: Hash tables configured (established 1024 bind 1024)
TCP reno registered
squashfs: version 3.0 (2006/03/15) Phillip Lougher
Registering mini_fo version $Id$
JFFS2 version 2.2. (NAND) (SUMMARY)  © 2001-2006 Red Hat, Inc.
io scheduler noop registered
io scheduler deadline registered (default)
Serial: 8250/16550 driver $Revision: 1.90 $ 2 ports, IRQ sharing disabled
serial8250: ttyS0 at MMIO 0x8610e00 (irq = 15) is a TI-AR7

I tried booting without serial and attach it later but without luck. Router still reboots in a loop

comment:6 Changed 10 years ago by paul@…

Loswillios,

The 'reboot in a loop' in probably a different problem. See 2830. My Fritz!Box 7140 is working here with .24, despite the serial being out for most of the boot.

comment:7 Changed 9 years ago by hydra

I'm seeing the same thing as loswillios on my ADAM2 Speedport W701V using r12613.

The serial hangs, it looks like the device continues to boot (as an led starts flashing about 30 seconds later) but i can't ping it or see any further serial port output.

It doesn't reboot by itself either.

comment:8 Changed 9 years ago by anonymous

i can confirm however that r12244 works, loswillios also reports that he doesn't have this issue with r12244 so it looks like something's been broken since that revision.

comment:9 Changed 9 years ago by hydra

I confirm there's definitely something wrong between r12435 and r12437.

the kernel still boots at r12437, serial communication is interrupted but then re-appears.

compare these two boot logs:

r12435

(AVM) EVA Revision: 1.203 Version: 1203
(C) Copyright 2005 AVM Date: Feb  7 2007 Time: 19:03:32 (1) 2 0-11111

[FLASH:] SPANSION Top-MirrorBit-Flash 8MB 32 Bytes WriteBuffer
[FLASH:](Eraseregion [0] 127 sectors a 64kB) 
[FLASH:](Eraseregion [1] 8 sectors a 8kB) 
[SYSTEM:] OHIO on 211MHz/125MHz 

Eva_AVM >go
AVM decompress Kernel:
..................done
start kernel
Linux version 2.6.25.16 (hydra@hydra01-debian4) (gcc version 4.1.2) #1 Thu Sep 18 00:11:34 BST 2008
console [early0] enabled
CPU revision is: 00018448 (MIPS 4KEc)
Clocks: Async mode
Clocks: Setting DSP clock
Clocks: base = 25000000, frequency = 125000000, prediv = 1, postdiv = 2, postdiv2 = 1, mul = 10
Clocks: Setting CPU clock
Adjusted requested frequency 211000000 to 211968000
Clocks: base = 35328000, frequency = 211968000, prediv = 1, postdiv = 1, postdiv2 = -1, mul = 6
Clocks: Setting USB clock
Adjusted requested frequency 48000000 to 48076920
Clocks: base = 125000000, frequency = 48000000, prediv = 13, postdiv = 1, postdiv2 = -1, mul = 5
TI AR7 (TNETD7200), ID: 0x002b, Revision: 0x11
Determined physical RAM map:
 memory: 02000000 @ 14000000 (usable)
Initrd not found or empty - disabling initrd
Zone PFN ranges:
  Normal      81920 ->    90112
Movable zone start PFN for each node
early_node_map[1] active PFN ranges
    0:    81920 ->    90112
Built 1 zonelists in Zone order, mobility grouping on.  Total pages: 8128
Kernel command line: init=/etc/preinit rootfstype=squashfs,jffs2, console=ttyS0,38400n8
Primary instruction cache 16kB, VIPT, 4-way, linesize 16 bytes.
Primary data cache 8kB, 4-way, VIPT, no aliases, linesize 16 bytes
Synthesized clear page handler (26 instructions).
Synthesized copy page handler (46 instructions).
PID hash table entries: 128 (order: 7, 512 bytes)
Dentry cache hash table entries: 4096 (order: 2, 16384 bytes)
Inode-cache hash table entries: 2048 (order: 1, 8192 bytes)
Memory: 28772k/32768k available (2016k kernel code, 3996k reserved, 430k data, 132k init, 0k highmem)
SLUB: Genslabs=7, HWalign=32, Order=0-1, MinObjects=4, CPUs=1, Nodes=1
Mount-cache hash table entries: 512
net_namespace: 444 bytes
NET: Registered protocol family 16
NET: Registered protocol family 2
IP route cache hash table entries: 1024 (order: 0, 4096 bytes)
TCP established hash table entries: 1024 (order: 1, 8192 bytes)
TCP bind hash table entries: 1024 (order: 0, 4096 bytes)
TCP: Hash tables configured (established 1024 bind 1024)
TCP reno registered
squashfs: version 3.0 (2006/03/15) Phillip Lougher
Registering mini_fo version $Id$
JFFS2 version 2.2. (NAND) (SUMMARY)  © 2001-2006 Red Hat, Inc.
io scheduler noop registered
io scheduler deadline registered (default)
Serial: 8250/16550 driver $Revision: 1.90 $ 2 ports, IRQ sharing disabled
serial8250: ttyS0 at MMIO 0x8610e00 (irq = 15) is a TI-AR7
console handover: boot [early0] -> real [ttyS0]
Fixed MDIO Bus: probed
sysfs: duplicate filename '0:00' can not be created
------------[ cut here ]------------
WARNING: at fs/sysfs/dir.c:424 sysfs_add_one+0x4c/0x15c()
Modules linked in:
Call Trace:
[<94107e64>] dump_stack+0x8/0x34
[<941218e4>] warn_on_slowpath+0x60/0x80
[<941c80c4>] sysfs_add_one+0x4c/0x15c
[<941c9980>] sysfs_create_link+0x120/0x2e0
[<94232de8>] bus_add_device+0xd4/0x14c
[<94231200>] device_add+0x278/0x548
[<9423ca44>] mdiobus_register+0x120/0x19c
[<942f4294>] cpmac_init+0x288/0x2d4
[<94364654>] kernel_init+0xe0/0x304
[<941037a0>] kernel_thread_helper+0x10/0x18

---[ end trace 607f535e27277dd7 ]---
phy 0 failed to register
cpmac-mii: probed
cpmac: device eth0 (regs: 08610000, irq: 27, phy: , mac: 00:1a:4f:cb:e2:d9)
physmap platform flash device: 00800000 at 10000000
physmap-flash.0: Found 1 x16 devices at 0x0 in 16-bit bank
 Amd/Fujitsu Extended Query Table at 0x0040
physmap-flash.0: Swapping erase regions for broken CFI table.
number of CFI chips: 1
cfi_cmdset_0002: Disabling erase-suspend-program due to code brokenness.
cmdlinepart partition parsing not available
RedBoot partition parsing not available
4 ar7part partitions found on MTD device physmap-flash.0
Creating 4 MTD partitions on "physmap-flash.0":
0x00000000-0x00010000 : "loader"
0x007f0000-0x00800000 : "config"
0x00010000-0x007f0000 : "linux"
0x000e0000-0x007f0000 : "rootfs"
mtd: partition "rootfs" set to be root filesystem
mtd: partition "rootfs_data" created automatically, ofs=210000, len=5E0000 
0x00210000-0x007f0000 : "rootfs_data"
ar7_wdt: timer margin 59 seconds (prescale 65535, change 57180, freq 62500000)
Registered led device: 1
Registered led device: 2
Registered led device: 3
Registered led device: 4
Registered led device: 5
vlynq0: regs 0x08611800, irq 29, mem 0x04000000
nf_conntrack version 0.5.0 (1024 buckets, 4096 max)
ip_tables: (C) 2000-2006 Netfilter Core Team
TCP vegas registered
NET: Registered protocol family 1
NET: Registered protocol family 17
802.1Q VLAN Support v1.8 Ben Greear <greearb@candelatech.com>
All bugs added by David S. Miller <davem@redhat.com>
VFS: Mounted root (squashfs filesystem) readonly.
Freeing unused kernel memory: 132k freed
Please be patient, while OpenWrt loads ...
Algorithmics/MIPS FPU Emulator v1.5
- preinit -
Press CTRL-C for failsafe
switching to jffs2
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00570000: 0x0001 instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00570004: 0xffff instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00570008: 0x01ff instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x0057000c: 0x01fe instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00570010: 0x3940 instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00570014: 0x01af instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00570018: 0x7541 instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x0057001c: 0x444d instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00570024: 0x0103 instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x00570028: 0x4d44 instead
Further such events for this erase block will not be printed
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b0000: 0x0001 instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b0004: 0xffff instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b0008: 0x01ff instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b000c: 0x01fe instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b0010: 0x3940 instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b0014: 0x01af instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b0018: 0x7541 instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b001c: 0x444d instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b0024: 0x0103 instead
jffs2_scan_eraseblock(): Magic bitmask 0x1985 not found at 0x005b0028: 0x4d44 instead
Further such events for this erase block will not be printed
mini_fo: using base directory: /
mini_fo: using storage directory: /jffs
- init -

Please press Enter to activate this console. |/-\|/<6>PHY: 0:1f - Link is Up - 100/Half
NET: Registered protocol family 8
NET: Registered protocol family 20
-


BusyBox v1.11.1 (2008-09-17 20:39:11 BST) built-in shell (ash)
Enter 'help' for a list of built-in commands.

  _______                     ________        __
 |       |.-----.-----.-----.|  |  |  |.----.|  |_
 |   -   ||  _  |  -__|     ||  |  |  ||   _||   _|
 |_______||   __|_____|__|__||________||__|  |____|
          |__| W I R E L E S S   F R E E D O M
 KAMIKAZE (bleeding edge, r12435) -------------------
  * 10 oz Vodka       Shake well with ice and strain
  * 10 oz Triple sec  mixture into 10 shot glasses.
  * 10 oz lime juice  Salute!
 ---------------------------------------------------
root@OpenWrt:/# <6>PPP generic driver version 2.4.2
ipt_time loading
registered device TI Avalanche SAR
Ohio250(7200/7100A2) detected
requesting firmware image "ar0700xx.bin"
Creating new root folder avalanche in the proc for the driver stats 
Texas Instruments ATM driver: version:[7.03.01.00]

root@OpenWrt:/# cat DSL in Sync
prroot@OpenWrt:/# cat proc/verroot@OpenWrt:/# cat proc/version 
Linux version 2.6.25.16 (hydra@hydra01-debian4) (gcc version 4.1.2) #1 Thu Sep 18 00:11:34 BST 2008
root@OpenWrt:/# reboot
root@OpenWrt:/# tn7atm_close: closing 0.0.38.5
tn7sar_teardown_complete called for channel 0
ChannelTeardown returned rc = 0
Restarting system.

<create new TFFS>

r12437

(AVM) EVA Revision: 1.203 Version: 1203
(C) Copyright 2005 AVM Date: Feb  7 2007 Time: 19:03:32 (1) 2 0-11111

[FLASH:] SPANSION Top-MirrorBit-Flash 8MB 32 Bytes WriteBuffer
[FLASH:](Eraseregion [0] 127 sectors a 64kB) 
[FLASH:](Eraseregion [1] 8 sectors a 8kB) 
[SYSTEM:] OHIO on 211MHz/125MHz 

Eva_AVM >go
AVM decompress Kernel:
.........................done
start kernel
Linux version 2.6.26.3 (hydra@hydra01-debian4) (gcc version 4.1.2) #1 Thu Sep 18 02:24:51 BST 2008
console [early0] enabled
CPU revision is: 00018448 (MIPS 4KEc)
Clocks: Async mode
Clocks: Setting DSP clock
Clocks: base = 25000000, frequency = 125000000, prediv = 1, postdiv = 2, postdiv2 = 1, mul = 10
Clocks: Setting CPU clock
Adjusted requested frequency 211000000 to 211968000
Clocks: base = 35328000, frequency = 211968000, prediv = 1, postdiv = 1, postdiv2 = -1, mul = 6
Clocks: Setting USB clock
Adjusted requested frequency 48000000 to 48076920
Clocks: base = 125000000, frequency = 48000000, prediv = 13, postdiv = 1, postdiv2 = -1, mul = 5
TI AR7 (TNETD7200), ID: 0x002b, Revision: 0x11
Determined physical RAM map:
 memory: 02000000 @ 14000000 (usable)
Initrd not found or empty - disabling initrd
Zone PFN ranges:
  Normal      81920 ->    90112
Movable zone start PFN for each node
early_node_map[1] active PFN ranges
    0:    81920 ->    90112
Built 1 zonelists in Zone order, mobility grouping on.  Total pages: 8128
Kernel command line: init=/etc/preinit rootfstype=squashfs,jffs2, console=ttyS0,38400n8
Primary instruction cache 16kB, VIPT, 4-way, linesize 16 bytes.
Primary data cache 8kB, 4-way, VIPT, no aliases, linesize 16 bytes
PID hash table entries: 128 (order: 7, 512 bytes)
Dentry cache hash table entries: 4096 (order: 2, 16384 bytes)
Inode-cache hash table entries: 2048 (order: 1, 8192 bytes)
Memory: 28804k/32768k available (1983k kernel code, 3964k reserved, 431k data, 128k init, 0k highmem)
SLUB: Genslabs=6, HWalign=32, Order=0-3, MinObjects=0, CPUs=1, Nodes=1
Mount-cache hash table entries: 512
net_namespace: 484 bytes
NET: Registered protocol family 16
NET: Registered protocol family 2
IP route cache hash table entries: 1024 (order: 0, 4096 bytes)
TCP established hash table entries: 1024 (order: 1, 8192 bytes)
TCP bind hash table entries: 1024 (order: 0, 4096 bytes)
TCP: Hash tables configured (established 1024 bind 1024)
TCP reno registered
NET: Registered protocol family 1
squashfs: version 3.0 (2006/03/15) Phillip Lougher
Registering mini_fo version $Id$
JFFS2 version 2.2. (NAND) (SUMMARY)  © 2001-2006 Red Hat, Inc.
msgmni has been set to 56
io scheduler noop registered
io scheduler deadline registered (default)
Serial: 8250/16550 driver $Revision: 1.90 $ 2 ports, IRQ sharing disabled
serial8250: ttyS0 at MMIO 0x8610e00 (irq = 15) is a TI-AR7



[ -- loads of blank lines appear -- ]



a- preinit -
Press CTRL-C for failsafe
jffs2 not ready yet; using ramdisk
mini_fo: using base directory: /
mini_fo: using storage directory: /tmp/root
- init -

Please press Enter to activate this console. PHY: 0:00 - Link is Up - 10/Half
NET: Registered protocol family 8
NET: Registered protocol family 20
PPP generic driver version 2.4.2
ipt_time loading
registered device TI Avalanche SAR
Ohio250(7200/7100A2) detected
requesting firmware image "ar0700xx.bin"
firmware: requesting ar0700xx.bin
Creating new root folder avalanche in the proc for the driver stats 
Texas Instruments ATM driver: version:[7.03.01.00]
jffs2_scan_eraseblock(): End of filesystem marker found at 0x0
jffs2_build_filesystem(): unlocking the mtd device... done.
jffs2_build_filesystem(): erasing all blocks after the end marker... DSL in Sync



BusyBox v1.11.1 (2008-09-18 02:15:26 BST) built-in shell (ash)
Enter 'help' for a list of built-in commands.

  _______                     ________        __
 |       |.-----.-----.-----.|  |  |  |.----.|  |_
 |   -   ||  _  |  -__|     ||  |  |  ||   _||   _|
 |_______||   __|_____|__|__||________||__|  |____|
          |__| W I R E L E S S   F R E E D O M
 KAMIKAZE (bleeding edge, r12437) -------------------
  * 10 oz Vodka       Shake well with ice and strain
  * 10 oz Triple sec  mixture into 10 shot glasses.
  * 10 oz lime juice  Salute!
 ---------------------------------------------------
root@OpenWrt:/# cat /prroot@OpenWrt:/# cat /proc/verroot@OpenWrt:/# cat /proc/version 
Linux version 2.6.26.3 (hydra@hydra01-debian4) (gcc version 4.1.2) #1 Thu Sep 18 02:24:51 BST 2008
root@OpenWrt:/# done.
mini_fo: using base directory: /
mini_fo: using storage directory: /jffs

root@OpenWrt:/# restart
/bin/ash: restart: not found
root@OpenWrt:/# reboot
root@OpenWrt:/# Restarting system.

<create new TFFS>

comment:10 Changed 9 years ago by matteo

  • Owner changed from developers to matteo
  • Status changed from new to assigned
  • Summary changed from AR7 serial is broken in 2.6.24 to AR7 serial is broken

Now i don't read anything past the serial initialization:

Booting...
Linux version 2.6.26.7 (matteo@raver) (gcc version 4.2.4) #1 Mon Nov 10 03:16:31 CET 2008
console [early0] enabled                                                                 
CPU revision is: 00018448 (MIPS 4KEc)                                                    
Clocks: Async mode                                                                       
Clocks: Setting DSP clock                                                                
Clocks: base = 25000000, frequency = 125000000, prediv = 1, postdiv = 2, postdiv2 = 1, mul = 10
Clocks: Setting CPU clock                                                                      
Adjusted requested frequency 211000000 to 211968000                                            
Clocks: base = 35328000, frequency = 211968000, prediv = 1, postdiv = 1, postdiv2 = -1, mul = 6
Clocks: Setting USB clock                                                                      
Adjusted requested frequency 48000000 to 48076920                                              
Clocks: base = 125000000, frequency = 48000000, prediv = 13, postdiv = 1, postdiv2 = -1, mul = 5
TI AR7 (TNETD7200), ID: 0x002b, Revision: 0x10                                                  
Determined physical RAM map:                                                                    
 memory: 01000000 @ 14000000 (usable)                                                           
Initrd not found or empty - disabling initrd                                                    
Zone PFN ranges:                                                                                
  Normal      81920 ->    86016                                                                 
Movable zone start PFN for each node                                                            
early_node_map[1] active PFN ranges                                                             
    0:    81920 ->    86016                                                                     
Built 1 zonelists in Zone order, mobility grouping off.  Total pages: 4064                      
Kernel command line: init=/etc/preinit rootfstype=squashfs,jffs2, console=ttyS0,38400n8         
Primary instruction cache 16kB, VIPT, 4-way, linesize 16 bytes.                                 
Primary data cache 8kB, 4-way, VIPT, no aliases, linesize 16 bytes                              
PID hash table entries: 64 (order: 6, 256 bytes)                                                
Dentry cache hash table entries: 2048 (order: 1, 8192 bytes)                                    
Inode-cache hash table entries: 1024 (order: 0, 4096 bytes)                                     
Memory: 12652k/16384k available (1929k kernel code, 3732k reserved, 405k data, 120k init, 0k highmem)
SLUB: Genslabs=6, HWalign=32, Order=0-3, MinObjects=0, CPUs=1, Nodes=1                               
Mount-cache hash table entries: 512                                                                  
net_namespace: 644 bytes                                                                             
NET: Registered protocol family 16                                                                   
NET: Registered protocol family 2                                                                    
IP route cache hash table entries: 1024 (order: 0, 4096 bytes)                                       
TCP established hash table entries: 512 (order: 0, 4096 bytes)                                       
TCP bind hash table entries: 512 (order: -1, 2048 bytes)                                             
TCP: Hash tables configured (established 512 bind 512)                                               
TCP reno registered                                                                                  
NET: Registered protocol family 1                                                                    
squashfs: version 3.0 (2006/03/15) Phillip Lougher                                                   
Registering mini_fo version $Id$                                                                     
JFFS2 version 2.2. (NAND) (SUMMARY)  © 2001-2006 Red Hat, Inc.                                       
msgmni has been set to 24                                                                            
io scheduler noop registered                                                                         
io scheduler deadline registered (default)                                                           
Serial: 8250/16550 driver $Revision: 1.90 $ 2 ports, IRQ sharing disabled                            
serial8250: ttyS0 at MMIO 0x8610e00 (irq = 15) is a TI-AR7

comment:11 follow-up: Changed 9 years ago by matteo

  • Component changed from packages to kernel
  • Priority changed from normal to high

Set priority to high: this bug prevents me do other AR7 development

comment:12 in reply to: ↑ 11 Changed 9 years ago by mstombs

Replying to matteo:

Set priority to high: this bug prevents me do other AR7 development

Is it any help this rev "works for me"?

[code]~=~=~=~=~=~=~=~=~=~=~= PuTTY log 2008.11.12 22:57:48 =~=~=~=~=~=~=~=~=~=~=~=
Basic POST completed... Success.
Last reset cause: Hardware reset (Power-on reset)

PSPBoot1.4 rev: 1.4.0.4
(c) Copyright 2002-2005 Texas Instruments, Inc. All Rights Reserved.

Press ESC for monitor... 3321

(psbl)

Booting...
Linux version 2.6.26.7 (user@…) (gcc version 4.1.2) #1 Mon Nov 10 21:54:48 GMT 2008
console [early0] enabled
CPU revision is: 00018448 (MIPS 4KEc)
TI AR7 (TNETD7300), ID: 0x0005, Revision: 0x57
Determined physical RAM map:

memory: 01000000 @ 14000000 (usable)

Initrd not found or empty - disabling initrd
Zone PFN ranges:

Normal 81920 -> 86016

Movable zone start PFN for each node
early_node_map[1] active PFN ranges

0: 81920 -> 86016

Built 1 zonelists in Zone order, mobility grouping off. Total pages: 4064
Kernel command line: init=/etc/preinit rootfstype=squashfs,jffs2, console=ttyS0,38400n8
Primary instruction cache 16kB, VIPT, 4-way, linesize 16 bytes.
Primary data cache 16kB, 4-way, VIPT, no aliases, linesize 16 bytes
PID hash table entries: 64 (order: 6, 256 bytes)
Dentry cache hash table entries: 2048 (order: 1, 8192 bytes)
Inode-cache hash table entries: 1024 (order: 0, 4096 bytes)
Memory: 12564k/16384k available (1996k kernel code, 3820k reserved, 422k data, 124k init, 0k highmem)
SLUB: Genslabs=6, HWalign=32, Order=0-3, MinObjects=0, CPUs=1, Nodes=1
Mount-cache hash table entries: 512
net_namespace: 644 bytes
NET: Registered protocol family 16
NET: Registered protocol family 2
IP route cache hash table entries: 1024 (order: 0, 4096 bytes)
TCP established hash table entries: 512 (order: 0, 4096 bytes)
TCP bind hash table entries: 512 (order: -1, 2048 bytes)
TCP: Hash tables configured (established 512 bind 512)
TCP reno registered
NET: Registered protocol family 1
squashfs: version 3.0 (2006/03/15) Phillip Lougher
Registering mini_fo version $Id$
JFFS2 version 2.2. (NAND) (SUMMARY) © 2001-2006 Red Hat, Inc.
msgmni has been set to 24
io scheduler noop registered
io scheduler deadline registered (default)
Serial: 8250/16550 driver $Revision: 1.90 $ 2 ports, IRQ sharing disabled
serial8250: ttyS0 at MMIO 0x8610e00 (irq = 15) is a TI-AR7
console handover: boot [early0] -> real [ttyS0]
serial8250: ttyS1 at MMIO 0x8610f00 (irq = 16) is a TI-AR7
Fixed MDIO Bus: probed
cpmac-mii: probed
cpmac cpmac.1: no PHY present
cpmac: device eth0 (regs: 08610000, irq: 27, phy: , mac: 00:12:17:73:fc:1b)
physmap platform flash device: 00800000 at 10000000
physmap-flash.0: Found 1 x16 devices at 0x0 in 16-bit bank

Amd/Fujitsu Extended Query Table at 0x0040

number of CFI chips: 1
cfi_cmdset_0002: Disabling erase-suspend-program due to code brokenness.
cmdlinepart partition parsing not available
RedBoot partition parsing not available
4 ar7part partitions found on MTD device physmap-flash.0
Creating 4 MTD partitions on "physmap-flash.0":
0x00000000-0x00010000 : "loader"
0x00010000-0x00020000 : "config"
0x00020000-0x00400000 : "linux"
0x000f0000-0x00400000 : "rootfs"
mtd: partition "rootfs" set to be root filesystem
mtd: partition "rootfs_data" created automatically, ofs=290000, len=170000
0x00290000-0x00400000 : "rootfs_data"
ar7_wdt: timer margin 59 seconds (prescale 65535, change 57180, freq 62500000)
Registered led device: status
vlynq0: regs 0x08611800, irq 29, mem 0x04000000
vlynq1: regs 0x08611c00, irq 33, mem 0x0c000000
TCP vegas registered
NET: Registered protocol family 17
Bridge firewalling registered
802.1Q VLAN Support v1.8 Ben Greear <greearb@…>
All bugs added by David S. Miller <davem@…>
VFS: Mounted root (squashfs filesystem) readonly.
Freeing unused kernel memory: 124k freed
Please be patient, while OpenWrt loads ...
Algorithmics/MIPS FPU Emulator v1.5

  • preinit -

Press CTRL-C for failsafe
switching to jffs2
mini_fo: using base directory: /
mini_fo: using storage directory: /jffs

  • init -

Please press Enter to activate this console. PHY: 0:1f - Link is Up - 100/Full
br-lan: Dropping NETIF_F_UFO since no NETIF_F_HW_CSUM feature.
device eth0 entered promiscuous mode
br-lan: port 1(eth0) entering learning state
NET: Registered protocol family 8
NET: Registered protocol family 20
PPP generic driver version 2.4.2
ip_tables: (C) 2000-2006 Netfilter Core Team
nf_conntrack version 0.5.0 (1024 buckets, 4096 max)
IPP2P v0.8.1_rc1 loading
IMQ driver loaded successfully.
Hooking IMQ before NAT on PREROUTING.
Hooking IMQ after NAT on POSTROUTING.
ipt_time loading
registered device TI Avalanche SAR
Sangam detected
requesting firmware image "ar0700xx.bin"
firmware: requesting ar0700xx.bin
br-lan: topology change detected, propagating
br-lan: port 1(eth0) entering forwarding state
tn7dsl_init : env var DSL_BIT_TMODE is set
tn7dsl_set_modulation : Setting mode to 0x10
tn7dsl_init : env var high_precision is set.
Creating new root folder avalanche in the proc for the driver stats
Texas Instruments ATM driver: version:[7.03.01.00]
DSL in Sync

BusyBox v1.11.3 (2008-11-12 00:08:06 GMT) built-in shell (ash)
Enter 'help' for a list of built-in commands.

_

| |.-----.-----.-----.| | | |.----.| |_

| - |_
_ | -| | | _ _|
|_||| ||

|| W I R E L E S S F R E E D O M

KAMIKAZE (bleeding edge, r13190) -------------------[/code]

comment:13 Changed 9 years ago by anonymous

Probably not formatted like that - this should be better

~=~=~=~=~=~=~=~=~=~=~= PuTTY log 2008.11.12 22:57:48 =~=~=~=~=~=~=~=~=~=~=~=
DSL out of sync
DSL in Sync

Basic POST completed...     Success.
Last reset cause: Hardware reset (Power-on reset)

PSPBoot1.4 rev: 1.4.0.4
(c) Copyright 2002-2005 Texas Instruments, Inc. All Rights Reserved.

Press ESC for monitor... 3321

(psbl) 

Booting...
Linux version 2.6.26.7 (user@vector.linux.net) (gcc version 4.1.2) #1 Mon Nov 10 21:54:48 GMT 2008
console [early0] enabled
CPU revision is: 00018448 (MIPS 4KEc)
TI AR7 (TNETD7300), ID: 0x0005, Revision: 0x57
Determined physical RAM map:
 memory: 01000000 @ 14000000 (usable)
Initrd not found or empty - disabling initrd
Zone PFN ranges:
  Normal      81920 ->    86016
Movable zone start PFN for each node
early_node_map[1] active PFN ranges
    0:    81920 ->    86016
Built 1 zonelists in Zone order, mobility grouping off.  Total pages: 4064
Kernel command line: init=/etc/preinit rootfstype=squashfs,jffs2, console=ttyS0,38400n8
Primary instruction cache 16kB, VIPT, 4-way, linesize 16 bytes.
Primary data cache 16kB, 4-way, VIPT, no aliases, linesize 16 bytes
PID hash table entries: 64 (order: 6, 256 bytes)
Dentry cache hash table entries: 2048 (order: 1, 8192 bytes)
Inode-cache hash table entries: 1024 (order: 0, 4096 bytes)
Memory: 12564k/16384k available (1996k kernel code, 3820k reserved, 422k data, 124k init, 0k highmem)
SLUB: Genslabs=6, HWalign=32, Order=0-3, MinObjects=0, CPUs=1, Nodes=1
Mount-cache hash table entries: 512
net_namespace: 644 bytes
NET: Registered protocol family 16
NET: Registered protocol family 2
IP route cache hash table entries: 1024 (order: 0, 4096 bytes)
TCP established hash table entries: 512 (order: 0, 4096 bytes)
TCP bind hash table entries: 512 (order: -1, 2048 bytes)
TCP: Hash tables configured (established 512 bind 512)
TCP reno registered
NET: Registered protocol family 1
squashfs: version 3.0 (2006/03/15) Phillip Lougher
Registering mini_fo version $Id$
JFFS2 version 2.2. (NAND) (SUMMARY)  © 2001-2006 Red Hat, Inc.
msgmni has been set to 24
io scheduler noop registered
io scheduler deadline registered (default)
Serial: 8250/16550 driver $Revision: 1.90 $ 2 ports, IRQ sharing disabled
serial8250: ttyS0 at MMIO 0x8610e00 (irq = 15) is a TI-AR7
console handover: boot [early0] -> real [ttyS0]
serial8250: ttyS1 at MMIO 0x8610f00 (irq = 16) is a TI-AR7
Fixed MDIO Bus: probed
cpmac-mii: probed
cpmac cpmac.1: no PHY present
cpmac: device eth0 (regs: 08610000, irq: 27, phy: , mac: 00:12:17:73:fc:1b)
physmap platform flash device: 00800000 at 10000000
physmap-flash.0: Found 1 x16 devices at 0x0 in 16-bit bank
 Amd/Fujitsu Extended Query Table at 0x0040
number of CFI chips: 1
cfi_cmdset_0002: Disabling erase-suspend-program due to code brokenness.
cmdlinepart partition parsing not available
RedBoot partition parsing not available
4 ar7part partitions found on MTD device physmap-flash.0
Creating 4 MTD partitions on "physmap-flash.0":
0x00000000-0x00010000 : "loader"
0x00010000-0x00020000 : "config"
0x00020000-0x00400000 : "linux"
0x000f0000-0x00400000 : "rootfs"
mtd: partition "rootfs" set to be root filesystem
mtd: partition "rootfs_data" created automatically, ofs=290000, len=170000 
0x00290000-0x00400000 : "rootfs_data"
ar7_wdt: timer margin 59 seconds (prescale 65535, change 57180, freq 62500000)
Registered led device: status
vlynq0: regs 0x08611800, irq 29, mem 0x04000000
vlynq1: regs 0x08611c00, irq 33, mem 0x0c000000
TCP vegas registered
NET: Registered protocol family 17
Bridge firewalling registered
802.1Q VLAN Support v1.8 Ben Greear <greearb@candelatech.com>
All bugs added by David S. Miller <davem@redhat.com>
VFS: Mounted root (squashfs filesystem) readonly.
Freeing unused kernel memory: 124k freed
Please be patient, while OpenWrt loads ...
Algorithmics/MIPS FPU Emulator v1.5
- preinit -
Press CTRL-C for failsafe
switching to jffs2
mini_fo: using base directory: /
mini_fo: using storage directory: /jffs
- init -

Please press Enter to activate this console. PHY: 0:1f - Link is Up - 100/Full
br-lan: Dropping NETIF_F_UFO since no NETIF_F_HW_CSUM feature.
device eth0 entered promiscuous mode
br-lan: port 1(eth0) entering learning state
NET: Registered protocol family 8
NET: Registered protocol family 20
PPP generic driver version 2.4.2
ip_tables: (C) 2000-2006 Netfilter Core Team
nf_conntrack version 0.5.0 (1024 buckets, 4096 max)
IPP2P v0.8.1_rc1 loading
IMQ driver loaded successfully.
Hooking IMQ before NAT on PREROUTING.
Hooking IMQ after NAT on POSTROUTING.
ipt_time loading
registered device TI Avalanche SAR
Sangam detected
requesting firmware image "ar0700xx.bin"
firmware: requesting ar0700xx.bin
br-lan: topology change detected, propagating
br-lan: port 1(eth0) entering forwarding state
tn7dsl_init : env var DSL_BIT_TMODE is set
tn7dsl_set_modulation : Setting mode to 0x10
tn7dsl_init : env var high_precision is set.
Creating new root folder avalanche in the proc for the driver stats 
Texas Instruments ATM driver: version:[7.03.01.00]
DSL in Sync



BusyBox v1.11.3 (2008-11-12 00:08:06 GMT) built-in shell (ash)
Enter 'help' for a list of built-in commands.

  _______                     ________        __
 |       |.-----.-----.-----.|  |  |  |.----.|  |_
 |   -   ||  _  |  -__|     ||  |  |  ||   _||   _|
 |_______||   __|_____|__|__||________||__|  |____|
          |__| W I R E L E S S   F R E E D O M
 KAMIKAZE (bleeding edge, r13190) -------------------

comment:14 Changed 9 years ago by aoz.syn@…

I've done some experimentation against 8.09_rc1 and have made some interesting strides. By splitting out the UART initialization in arch/mips/ar7/platform.c to its own function, then setting console_initcall to that (commenting out the "return 0" one in setup.c), I get the first coherent AR7 boot console I've had in a long time.

Will post the patch in a bit; currently doing a little more debugging, but it's quite promising!

comment:15 Changed 9 years ago by alex@…

From 'aoz.syn's comment above I was able to throw a suitable patch together.

http://stuff.digriz.org.uk/ar7-serial-fix.diff

I'll host it for a while until someone fixes up the actual calling code upstream.

comment:16 Changed 9 years ago by aoz.syn@…

Sorry I left this off - got distracted chasing something else. I found more, and the issue seems not to be splitting out the serial initialization, it's that the UART gets initialized multiple times. By splitting it out I (and I assume Alex as well) actually prevented the platform-specific initialization code from running and corrupting the setup.

The UART is being discovered and initialized elsewhere for early console; by re-initializing it we're interrupting and possibly incorrectly setting it up. The early boot code is rather convoluted and as a newcomer to it I wasn't able to work out precisely where we were conflicting with existing kernel code.

comment:17 Changed 9 years ago by florian

The patch you pasted is now a dead link, can you please attach it to this ticket so that we can have a look at it ?

comment:18 Changed 9 years ago by frank

I had the same problem with yesterday's trunk source.
It's fixed now after doing a 'make kernel_menuconfig' and changing 'serial ports initialized' from 2 to 1.

comment:19 Changed 9 years ago by frank

Then (AVM 7141 router/ r14768) it hang after this line:
vlynq0: regs 0x08611800, irq 29, mem 0x04000000

After disabling 'TI vlynq' in the kernel, the device boots perfectly.
Login by minicom or ssh works.

comment:20 Changed 9 years ago by skyburner@…

using the aktual branch i only had to
make kernel_menuconfig
and disable TI vlynq
i left
Character devices ---> Serial drivers ---> (2) Maximum number of 8250/16550 serial ports (2) Number of 8250/16550 serial ports to register at runtime
as it is.
Terminal works, ssh works
What is TI vlynq for?

Changed 9 years ago by anonymous

Changed 9 years ago by anonymous

Changed 9 years ago by anonymous

comment:21 Changed 9 years ago by mstombs

attachment is as downloaded on 25/01/2009 from link posted by alex

the 2nd and 3rd are identical - keyboard enter auto-repeat!

comment:22 Changed 9 years ago by florian

  • Owner changed from matteo to florian
  • Status changed from assigned to new

comment:23 Changed 8 years ago by florian

  • Resolution set to fixed
  • Status changed from new to closed

I believe that everything is now fixed wrt the serial ports.

comment:24 Changed 7 years ago by frank@…

  • Resolution fixed deleted
  • Status changed from closed to reopened

well, latest revision still freezes after the line vlynq0..
this is a fritzbox 7141.
it seems vsynq is now hardcoded to be on.. so what a hassle now to remove it..

comment:25 Changed 7 years ago by florian

  • Resolution set to fixed
  • Status changed from reopened to closed

Your problem is covered by #7324, closing.

comment:26 Changed 4 years ago by oswald.buddenhagen@…

i see the same effect with r40526, kernel 3.10.36.

the log ends with

[    0.480000] Serial: 8250/16550 driver, 16 ports, IRQ sharing enabled
[    0.510000] serial8250: ttyS0 at MMIO 0x8610e00 (irq = 15) is a TI-AR7

the number of ports is "a bit" suspicious ...

the box resets shortly afterwards, so no idea what is going on.

comment:27 Changed 4 years ago by oswald.buddenhagen@…

i normalized the number of ports by unselecting the kmod-serial-8250 option (as it adds some weird overrides to the kernel config).
however, that did not change the overall behavior.

comment:28 follow-up: Changed 4 years ago by oswald.buddenhagen@…

turns out the problem is quite different despite identical effect:

--- a/arch/mips/ar7/platform.c
+++ b/arch/mips/ar7/platform.c
@@ -581,6 +581,7 @@ static int __init ar7_register_uarts(void)
        uart_port.type          = PORT_AR7;
        uart_port.uartclk       = clk_get_rate(bus_clk) / 2;
        uart_port.iotype        = UPIO_MEM32;
+       uart_port.flags         = UPF_FIXED_TYPE;
        uart_port.regshift      = 2;

        uart_port.line          = 0;

comment:29 in reply to: ↑ 28 Changed 4 years ago by olebowle

  • Resolution fixed deleted
  • Status changed from closed to reopened

Replying to oswald.buddenhagen@…:

turns out the problem is quite different despite identical effect:

--- a/arch/mips/ar7/platform.c
+++ b/arch/mips/ar7/platform.c
@@ -581,6 +581,7 @@ static int __init ar7_register_uarts(void)
        uart_port.type          = PORT_AR7;
        uart_port.uartclk       = clk_get_rate(bus_clk) / 2;
        uart_port.iotype        = UPIO_MEM32;
+       uart_port.flags         = UPF_FIXED_TYPE;
        uart_port.regshift      = 2;

        uart_port.line          = 0;

I can confirm this patch brings back fully functional serial connection.

comment:30 Changed 3 years ago by florian

  • Resolution set to fixed
  • Status changed from reopened to closed

Patch applied in r41363

Add Comment

Modify Ticket

Action
as closed .
The resolution will be deleted. Next status will be 'reopened'.
Author


E-mail address and user name can be saved in the Preferences.

 
Note: See TracTickets for help on using tickets.